<template>
  <v-container fluid>
    <v-card class="ma-3 pa-3">
      <v-card-title primary-title>
        <div class="headline primary--text">Dashboard</div>
      </v-card-title>
      <v-card-text>
        <div class="headline font-weight-light ma-5">Welcome {{greetedUser}}</div>
      </v-card-text>
      <v-card-actions>
        <v-btn to="/main/profile/view">View Profile</v-btn>
        <v-btn to="/main/profile/edit">Edit Profile</v-btn>
        <v-btn to="/main/profile/password">Change Password</v-btn>
      </v-card-actions>
    </v-card>
    <v-card class="ma-3 pa-3">
      <v-card-title primary-title>
        <div class="headline primary--text">Feed</div>
      </v-card-title>
      <v-card-text>
        <div class="headline font-weight-light ma-5"></div>
        <v-form ref="form" lazy-validation>
          <v-text-field label="Echo Input" v-model="echoText" required></v-text-field>
        </v-form>
        <ul id='messages'>
        </ul>
      </v-card-text>
      <v-card-actions>
        <v-btn @click="echoMessage">Echo</v-btn>
      </v-card-actions>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { Store } from 'vuex';
import { readUserProfile } from '@/store/main/getters';

const ws = new WebSocket('ws://localhost/ws');
ws.onmessage = (event) => {
    const messages = document.getElementById('messages');
    const message = document.createElement('li');
    const content = document.createTextNode(event.data);
    message.appendChild(content);
    if (messages) {
      messages.appendChild(message);
    }
};

@Component
export default class Dashboard extends Vue {

  public echoText: string = '';

  get greetedUser() {
    const userProfile = readUserProfile(this.$store);
    if (userProfile) {
      if (userProfile.full_name) {
        return userProfile.full_name;
      } else {
        return userProfile.email;
      }
    }
  }
  public echoMessage() {
    ws.send(this.echoText);
  }
}
</script>
